/* REXX - Rulez 
   PortScanner 1 // (c) 1998, Andrew Alexeyenko, chaos@falt.deep.ru
*/
PARSE ARG address

IF address='' THEN DO
    SAY 'USAGE: PortScan1.CMD <dotted ip address>'
    exit
    END

call rxFuncAdd "SysGetKey", "RexxUtil", "SysGetKey"
rc = RxFuncAdd("SockLoadFuncs","rxSock","SockLoadFuncs")
rc = SockLoadFuncs()

serv='services'
outfile='ping.out'

    newadr=address
    SAY 'Connecting to 'newadr

    '@ping 'newadr' 1 1 > ping.out'

    a = LINEIN(outfile)
    a = LINEIN(outfile)
    rc = STREAM(outfile,'C','close')

    IF SUBSTR(a,1,1)='9' THEN 
    DO
        SAY 'Successfuly connected with 'newadr', services present:'
        rc=STREAM(serv,'C','open read')

        addr.addr=newadr
        addr.family = AF_INET

        DO WHILE STREAM(serv) = 'READY'
            PARSE VALUE LINEIN(serv) WITH addr.port comment

            sock = SockSocket(AF_INET, SOCK_STREAM, 0)
            IF sock>-1 THEN 
            DO
                rc = SockConnect(sock,"addr.")
                IF rc>-1 THEN SAY ' 'comment' (port 'addr.port')'
            END
            ELSE SAY 'Unable to get socket.'
            rc = SockClose(sock)
        END
        rc = STREAM(serv,'C','close')
    END
rc = SockDropFuncs()
'@del ping.out'
