/* REXX - Rulez
 PortScanner 2 // (c) 1998, Andrew Alexeyenko, chaos@falt.deep.ru
 */
PARSE ARG address pfrom pto unap

IF address='' || pfrom='' || pto='' THEN DO
    SAY 'USAGE: PortScan1.CMD <dotted ip address> <begin port> <end port> [anything - print unavailable ports]'
    exit
    END

call rxFuncAdd "SysGetKey", "RexxUtil", "SysGetKey"
rc = RxFuncAdd("SockLoadFuncs","rxSock","SockLoadFuncs")
rc = SockLoadFuncs()

SAY 'Connecting to 'address', scanning range: 'pfrom'-'pto

addr.addr=address
addr.family = AF_INET

DO port=pfrom TO pto
    addr.port =port

    sock = SockSocket(AF_INET, SOCK_STREAM, 0)
    IF sock>-1 THEN
        DO
            rc = SockConnect(sock,"addr.")
            IF rc>-1 THEN SAY ' port 'addr.port
            ELSE if \(unap='')
            THEN SAY '                 port 'addr.port' is not available'
            END
    ELSE SAY 'Unable to get socket.'
    rc = SockClose(sock)
    END
rc = STREAM(serv,'C','close')
rc = SockDropFuncs()
